#ifndef KEYSERV_H_
#define KEYSERV_H_ 1


/* keyserv.c */

extern unsigned server_keybytes;
extern unsigned server_keybits;
extern unsigned server_hexkeybytes;

void writerootkey(keybuf_long secret);
void readkeys(unsigned keybytes);

void sesskey_des_setparity(unsigned char *p);
void convkey_des_setparity(unsigned char *p);


/* key_generic.c */
int svc_create_local_service(void (*dispatch)(struct svc_req *rqstp, SVCXPRT *transp), 
			     u_long prognum, u_long versnum, char *nettype, char *servname);


/* setkey.c */

int openstore(unsigned keybytes);

void pk_nodefaultkeys(void);
void pk_nodiskkeystore(void);
void setmodulus(keybuf_long);

keystatus pk_setkey_long(uid_t, keybuf_long);
keystatus pk_encrypt(uid_t uid, netnamestr remote_name, netobj * remote_key,
	   des_block *key);
keystatus
pk_decrypt(uid_t uid, netnamestr remote_name, netobj * remote_key,
	   des_block *key);
keystatus pk_netput_long(uid_t uid, key_netstarg_long *netstore);
keystatus pk_netget_long(uid_t uid, key_netstarg_long *netstore);
keystatus pk_get_convlong_key(uid_t uid, keybuf_long xpublic, cryptkeyres * result);

/* detach.c */

void detachfromtty(void);

/* des_soft.c */

extern int convkey_8bit;

void sesskey_des_setparity(unsigned char *p);
void convkey_des_setparity(unsigned char *p);

#endif /* KEYSERV_H_ */
